/*
 * $Id: err.h,v 1.1.1.1 2002/11/28 08:51:56 eli7 Exp $
 */

/*  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef __ERR_H__
#define __ERR_H__

#include <stdio.h>

#ifdef DEBUG

#define BUG() \
	fprintf(stderr, \
		"BUG! '%s':%4d %s()\n", \
	       __FILE__, __LINE__, __PRETTY_FUNCTION__)
#define BUGF(args...)  {   \
	fprintf(stderr, \
		"BUG! '%s':%4d %s() ", \
	       __FILE__, __LINE__, __PRETTY_FUNCTION__); \
	fprintf(stderr, args);    \
        fprintf(stderr,"\n"); }
#else
#define BUG()
#define BUGF(fmt,args...)
#endif /* DEBUG */

const char *errnostr();

#endif /* __ERR_H__ */
