/*
 * $Id: ll.h,v 1.1.1.1 2002/11/28 08:51:56 eli7 Exp $
 */

/*  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef __LL_H__
#define __LL_H__

typedef struct linked_list {
	struct linked_list *next;
	void *data;
} ll_t;

typedef int (*cmpfunc_t)(void *a, void *b);
typedef int (*iteratorfunc_t)(void *data, void *args);


int ll_init(ll_t *this);
void ll_die(ll_t *this);

int ll_data(ll_t *this, void **data);
ll_t* ll_next(ll_t *this);

int ll_insert(ll_t *this, void *data);
int ll_delete(ll_t *this, void **data);

ll_t* ll_find(ll_t *this, cmpfunc_t cmp, void *data);
int ll_iterate(ll_t *this, iteratorfunc_t iterator, void *args);

#endif /* __LL_H__ */
