/*
 * $Id: pq.c,v 1.1.1.1 2002/11/28 08:51:56 eli7 Exp $
 */

/*  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

static char *rcsid =
        "$Id: pq.c,v 1.1.1.1 2002/11/28 08:51:56 eli7 Exp $";

#include "err.h"
#include "ll.h"
#include "pq.h"
#include <stdlib.h>


int 
pq_topq(ll_t *this, void **data)
{
	return ll_data(this, data);	
}

int
pq_deq(ll_t *this, void **data)
{
	return ll_delete(this, data);
}

int
pq_enq(ll_t *this, void *data, cmpfunc_t cmp)
{
	void *odata;
	
	if (this == NULL) {
		BUG();
		return -1;
	}
	while (ll_data(this, &odata) != -1) {
		if (cmp(odata, data) >= 0) {
			break;
		}
		this = ll_next(this);
	}
	ll_insert(this, data);
	return 0;
}
