/*
 * $Id: scheme_glue.c,v 1.1.1.1 2002/11/28 09:02:09 eli7 Exp $
 */

/*  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

static char *rcsid =
        "$Id: scheme_glue.c,v 1.1.1.1 2002/11/28 09:02:09 eli7 Exp $";

// scheme_glue.c: Interface midi-lib -> MzScheme
#include "midi.h"
#include <escheme.h>

void error_handler(char *str)
{
  scheme_signal_error("libmidi: %s", str);
}

Scheme_Object *scheme_play_note(int argc, Scheme_Object **argv) {
  int i, ok = 1;
  unsigned long start, duration;

  for (i = 0; i < 4; i++) {
  	if (!SCHEME_INTP(argv[i])) {
		 scheme_wrong_type("play-note", "fixnum", i, argc, argv);
	}
  }
// FIXME ! unsigned
	if (!scheme_get_unsigned_int_val(argv[3], &start)
  	  || !scheme_get_unsigned_int_val(argv[1], &duration)) {
    	scheme_signal_error("Arg error in scheme_play_note");
	} else {
  		play_note(SCHEME_INT_VAL(argv[0]), duration,
				SCHEME_INT_VAL(argv[2]), start);
	}
  return scheme_undefined;
}

Scheme_Object *scheme_midi_get_time(int argc, Scheme_Object **argv) {
// FIXME
  return scheme_make_integer_value_from_unsigned((unsigned long)midi_get_time());
}


Scheme_Object *scheme_midi_open(int argc, Scheme_Object **argv) 
{
	if (midi_open() == -1) {
		return scheme_false;
	}
	return scheme_true;
}

Scheme_Object *scheme_midi_close(int argc, Scheme_Object **argv) 
{
	midi_close();
	return scheme_true;
}

Scheme_Object *scheme_initialize(Scheme_Env *env) {
  Scheme_Object *args[1];

  scheme_add_global("play-note",
                    scheme_make_prim_w_arity(scheme_play_note,
                                             "play-note", 4, 4),
                    env);
  scheme_add_global("midi-open",
                    scheme_make_prim_w_arity(scheme_midi_open,
                                             "midi-open", 0, 0),
                    env);
  scheme_add_global("midi-close",
                    scheme_make_prim_w_arity(scheme_midi_close,
                                             "midi-close", 0, 0),
                    env);
  scheme_add_global("midi-get-time",
                    scheme_make_prim_w_arity(scheme_midi_get_time,
                                             "midi-get-time", 0, 0),
                    env);
  
  //midi_set_error(error);

  args[0] = scheme_make_string("~n"
								"------------------~n"
                               "welcome to libmidi~n"
                               "------------------~n");
  scheme_apply(scheme_lookup_global(scheme_intern_symbol("printf"), env),
               1, args);
  return scheme_true;
}

Scheme_Object *scheme_reload(Scheme_Env *env) {
  return scheme_true;
}

Scheme_Object *scheme_module_name()
{
  /* This extension doesn't define a module: */
  return scheme_false;
}

